function generate_div(str){
  if(!str || $character.display == 'none') return '';

  //str = str.replace(/\uFFFD/g, ' ');
  var pos = convertMN2XY($cursor.position);
  var lengthOfText = stringLen(str);
  if(str.match(/&|<|>|"/g)){
     str = str.replace(/&/g, '&amp;');
     str = str.replace(/</g, '&lt;');
     str = str.replace(/>/g, '&gt;');
     str = str.replace(/"/g, '&quot;');
  }

  var s = '<div';
  s += ' id="m' + $cursor.position.m + 'n' + $cursor.position.n + 'n' + ($cursor.position.n + lengthOfText) + '"';
  s += 'class="terminal_display" '
  s += ' style="';
  s += 'left: ' + pos[0] + 'px;';
  s += 'top: ' + pos[1] + 'px;';
  s += 'width: ' + (lengthOfText * $character.fontWidth) + 'px;';
  
  if($character.italic)
    s += 'font-style: ' + $character.getProperty('font-style') + ';';

  if($character.underline || $character.blink)
    s +=  'text-decoration: ' + $character.getProperty('text-decoration') + ';';

  s += 'color: ' + $character.getProperty('color') + ';';
  s += 'background-color: ' + $character.getProperty('background-color') + ';">';
  s += str + '</div>';

  $garbage_div_collector.setRange($cursor.position.m, [$cursor.position.n, $cursor.position.n + lengthOfText]);
  $cursor.setPosition($cursor.position.m, $cursor.position.n + lengthOfText);
  return s;
}

function generate_black_div(cursorPosition, cols){
  var pos = convertMN2XY($cursor.position);
  var s = '<div';
  s += ' id="m' + cursorPosition.m + 'n' + cursorPosition.n + 'n' + (cursorPosition.n + cols) + '"';
  s += 'class="terminal_display" '
  s += ' style="';
  s += 'left: ' + pos[0] + 'px;';
  s += 'top: ' + pos[1] + 'px;';
  s += 'background-color: black;'
  s += 'width: ' + (cols * $character.fontWidth) + 'px"> </div>';
  $garbage_div_collector.setRange($cursor.position.m, [cursorPosition.n, cursorPosition.n + cols]);
  return s;
}

function convertMN2XY(cursorPosition){
  var origin = [FireBBS.output_area.offsetLeft + 1,
                FireBBS.output_area.offsetTop + 1];
  var realX = origin[0] + (cursorPosition.n - 1) * $character.fontWidth;
  var realY = origin[1] + (cursorPosition.m - 1) * $character.fontHeight;
  return [realX, realY];
}

function stringLen(str){
  str2 = str.replace(/[\x00-\xFF\uFFFD]/g, '');
  return str.length + str2.length;
}

function showMSG(str){
  document.getElementById('msg').innerHTML += str;
}